<?php
/**
 * @package Save_Search_on_Wordpress
 * @author R&eacute;gis COLLIN
 * @version 0.1
 */
/*
Plugin Name: Save Search on Worpdress
Plugin URI: http://www.webotheque.fr/save-search-on-wordpress.php
Description: This plugin is designed to store a database of all searches on your blog with the search engine Wordpress. Thus, it is possible to create a wordcloud with the keywords most wanted or just to see which words are searched.
Author: R&eacute;gis COLLIN
Version: 0.1
Author URI: http://www.webotheque.fr/
*/




class wp_save_search {
	
	private $nb_caract = '';				//Number max of letter for save search ## Nombre de caractres  partir duquel on sauvegarde la recherche
	private $your_email = '';				//email admin ## email administrateur o recevoir les mails d'alertes
	private $nb_words = '';					//Number max for words in wordcloud ## Nombre de mot  afficher dans le nuage de tags
	
	function __construct($mode = 'install'){
		global $wpdb;
		$wpdb -> tbl_SSW = $wpdb -> prefix.'save_search';
		$wpdb -> tbl_SSW_CONF = $wpdb -> prefix.'save_search_conf';
		if($mode == "install")
			add_action('admin_menu',array(&$this,'my_admin_menu'));
		else
			$this -> nb_caract=get_option('nb_caract');
	}

	function my_admin_menu() {
		//Add entry menu plugins
		add_submenu_page('plugins.php',"wp_save_search","Search on Wordpress",8, __FILE__,array(&$this,'homepage'));		
	}
	
	function homepage(){ // Update parameters - Mise  jour des paramtres
		$this->install();
		global $wpdb;
		
		if(isset($_POST['choice_nbcaract']) && !empty($_POST['choice_nbcaract']) && is_numeric($_POST['choice_nbcaract'])){
			$this->nb_caract = intval($_POST['choice_nbcaract']);
			$update_nb = $wpdb -> query("UPDATE $wpdb->tbl_SSW_CONF SET nb_caract = '".$this -> nb_caract."'");
		}
		if(isset($_POST['alertemail']) && !empty($_POST['alertemail'])){
			$this->alert_email = addslashes($_POST['alertemail']);
			$update_nb = $wpdb -> query("UPDATE $wpdb->tbl_SSW_CONF SET alert_email  = '".$this -> alert_email."'");
		}
		if(isset($_POST['monemail']) && !empty($_POST['monemail'])){
			$this->your_email = addslashes($_POST['monemail']);
			$update_nb = $wpdb -> query("UPDATE $wpdb->tbl_SSW_CONF SET mail_admin  = '".$this -> your_email."'");
		}
		if(isset($_POST['nb_word_in_cloud']) && !empty($_POST['nb_word_in_cloud'])){
			$this->nb_words = intval($_POST['nb_word_in_cloud']);
			$update_nb = $wpdb -> query("UPDATE $wpdb->tbl_SSW_CONF SET nb_word  = '".$this -> nb_words."'");
		}
		if(isset($_POST['all_the_words'])){	// Update words to show in wordcloud - Mise  jour  des mots  afficher dans le nuage de tags		
			$words_checked = explode('@@',$_POST['all_the_words']);
			for($wd = 0; $wd < sizeof($words_checked); $wd++){
				
				if($_POST['the_words_'.$words_checked[$wd]])
					$update_word = $wpdb -> query("UPDATE $wpdb->tbl_SSW SET word_approuved = 1 WHERE word_id = '".$_POST['the_words_'.$words_checked[$wd]]."'");
				else
					$update_word = $wpdb -> query("UPDATE $wpdb->tbl_SSW SET word_approuved = 0 WHERE word_id = '".$words_checked[$wd]."'");
			}
		}
			
		echo "<div class='wrap'>";
		echo '<h2>' . __('Save Search on Worpdress') . '</h2>';
		echo '<p>Save Search on Wordpress by <a href="http://www.webotheque.fr">webotheque</a>.</p>';
		
		$this->main_form();
		
		echo("</div>");
	}
	
	function main_form(){// display parameters form - Affiche le formulaire de paramtres
		global $wpdb; $check_word = ''; $w = 0; $selectAlertEmail = '';
		$nbcaract = $wpdb -> get_results("SELECT * FROM $wpdb->tbl_SSW_CONF");
		$last_view = $nbcaract[0] -> last_view;
		$state_alerte = array("oui" ,"non");
		
		foreach($state_alerte AS $state){
			$selected = ($nbcaract[0] -> alert_email == $state) ? 'selected = "selected"' : '';
			$selectAlertEmail .= '<option value="'.$state.'" '.$selected.'>'.$state.'</option>';
		}
		
		echo '<form method="post"><table  width="100%">';
		echo '<h2 style="color: #000;">' . __('Options') . '</h2>';
		echo '<tr><td style="width: 520px;">Nombre de caract&egrave;res maximum pour sauvegarder les mots recherch&eacute;s</td><td> <input type="text" name="choice_nbcaract" value="'.$nbcaract[0] -> nb_caract.'" style="width: 250px;"/></td></tr>';
		echo '<tr><td>Je souhaite recevoir les alertes email </td><td><select name="alertemail" style="width: 250px;">'.$selectAlertEmail.'</select></td></tr>';
		echo '<tr><td>Adresse e-mail o&ugrave; vous souhaitez recevoir les alertes </td><td><input type="text" name="monemail" value="'.$nbcaract[0] -> mail_admin.'" style="width: 250px;"/></td></tr>';
		echo '<tr><td>Nombre max de mots cl&eacute;s recherch&eacute;s &agrave; afficher dans la nuage de mots cl&eacute;s </td><td><input type="text" name="nb_word_in_cloud" value="'.$nbcaract[0] -> nb_word.'" style="width: 250px;"/></td></tr>';
		$word_searched = $wpdb -> get_results("SELECT * FROM $wpdb->tbl_SSW ORDER BY word_time DESC");
		if($word_searched != null){
			$check_word = '<td colspan="2"><h2 style="color: #000;">' . __('Recherches') . '</h2>NB: Les mots apparaissant en rouge repr&eacute;sentent les mots recherch&eacute;s depuis votre derni&egrave;re visite sur cette page.<br /><br /><table width="100%" cellpadding="5" style="margin-top: 15px; border: 1px solid;"><tr><td align="center" colspan="3" style="height: 50px; font-size: 15px; vertical-align: middle; background: #eeeeee;"><b>Mots cl&eacute;s recherch&eacute;s sur votre site</b><br /> cochez les mots que vous souhaitez faire appara&icirc;tre sur votre site</td></tr>';
			foreach($word_searched AS $one_word){
				$check_word .= ($w == 0) ? '<tr>' : '';
				$check_word .= ($w%3 == 0 && $w != 0) ? '</tr><tr>' : '';
				$checked = ($one_word -> word_approuved == 1) ? 'checked="checked"' : '';
				$color_word = ($one_word -> word_last_search_date > $last_view) ? 'red' : '';
				$check_word .= '<td style="border: 0px solid;"><input type="checkbox" name="the_words_'.$one_word -> word_id.'" id="word_'.$one_word -> word_id.'" '.$checked.' value="'.$one_word -> word_id.'" /> &nbsp; <label for="word_'.$one_word -> word_id.'" style="color: '.$color_word.';">'.stripslashes($one_word -> word_name).' ('.$one_word -> word_time.')</label></td>';
				$w++;
				$all_the_words .= $one_word -> word_id.'@@';
			}
			$td_manquant = 3 - $w%3;
			if($td_manquant < 3){
				for($t = 0; $t < $td_manquant; $t++)
					$check_word .= '<td style="border: 0px solid;">&nbsp;</td>';
			}
			
			$check_word .= '</tr>';
			$check_word .= '<input type="hidden" name="all_the_words" value="'.substr($all_the_words,0,-2).'" /></td></tr></table>';
			echo $check_word;
		}
		echo '</table>';
		echo '<p class="submit"><input type="submit" name="submit" value="Update" /></p>';
		
		echo "</form>";		
		$wpdb -> query('UPDATE '.$wpdb->tbl_SSW_CONF.' SET last_view = "'.time().'"');
	}

	function install() {
		global $wpdb;
		if(get_option('wp_save_search_init')){
			//return;
		}
		
		$charset_collate = '';
		if ( version_compare(mysql_get_server_info(), '4.1.0', '>=') ) {
			if (!empty($wpdb->charset)) {
				$charset_collate .= " DEFAULT CHARACTER SET $wpdb->charset";
			}
			if (!empty($wpdb->collate)) {
				$charset_collate .= " COLLATE $wpdb->collate";
			}
		}
		// Create table required for plugin
		$result = $wpdb->query("
				CREATE TABLE `$wpdb->tbl_SSW` (
			  `word_id` bigint(20) unsigned NOT NULL auto_increment,
			  `word_name` varchar(255) NOT NULL default '',
			  `word_time` int(11) NOT NULL default '0',
			  `word_last_search_date` int(11) NOT NULL default '0',
			  `word_approuved` int(1) NOT NULL default '0',
			  PRIMARY KEY  (`word_id`)
			) $charset_collate");
		$result_2 = $wpdb->query("
				CREATE TABLE `$wpdb->tbl_SSW_CONF` (
			  `id_nb_caract` int(1) unsigned NOT NULL auto_increment,
			  `nb_caract` int(5) NOT NULL default '90',
			  `mail_admin` varchar(255) NOT NULL default 'votreadresse@mail.com',
			  `nb_word` int(11) NOT NULL default '15',
			  `last_view` int(11) NOT NULL default '0',
			  `alert_email` varchar(3) NOT NULL default 'oui',
			  PRIMARY KEY  (`id_nb_caract`)
			) $charset_collate");
		$search_1 = $wpdb -> get_results("SELECT * FROM $wpdb->tbl_SSW_CONF");
		if($search_1 == null)
			$result_3 = $wpdb->query("INSERT INTO `$wpdb->tbl_SSW_CONF` (nb_caract,mail_admin,last_view) VALUES (90,'votreadresse@mail.com','".time()."')");
		
		$this->mem_option('wp_save_search_init',true);
	}

	/* Generic admin functions */

	function mem_option($name,$value=""){
		if(!add_option($name,$value)){
			update_option($name,$value);
		}
	}
}

//Use from plugin manager

function wp_save_search_init() {
	$tw = new wp_save_search;
}

add_action('plugins_loaded','wp_save_search_init');


function is_one_search($search,$link = 0){// Function loaded on each page ## Fonction appele  chaque chargement de page
	if(isset($search) && $search != '' && intval($link) == 0){ // If search ## Si une recherche est effectue
		global $wpdb; 
		$table =  $wpdb -> prefix.'save_search_conf';
		$get_conf = $wpdb -> get_results("SELECT * FROM $table WHERE id_nb_caract = 1");
		$NBMAX = $get_conf[0] -> nb_caract;
		if($NBMAX >= strlen($search))	// Si la longueur du mot recherch est valide (c--d nfrieure  celle slectionne dans l'admin, on enregistre la recherche)
			trace_search($_GET['s']);
		else if($get_conf[0] -> alert_email == 'oui')// Sinon on envoie par mail le terme recherch  l'administrateur du site
			send_search($search);
	}
}

function trace_search($var){ // Save search ## sauvegarde la recherche
	global $wpdb;
	$var = addslashes($var);
	$table = $wpdb -> prefix.'save_search';
	$yet_in_db = $wpdb -> get_results('SELECT * FROM '.$table.' WHERE word_name = "'.$var.'"');// Verify iif search is yet in database ## Vrifie si la recherche a dj t effectue
	if($yet_in_db == null)
		$wpdb->query('INSERT INTO '.$table.' (word_name,word_time,word_last_search_date) VALUES ("'.$var.'",1,"'.time().'")');
	else{
		$wpdb -> query('UPDATE '.$table.' SET word_time = word_time + 1, word_last_search_date = "'.time().'" WHERE word_id = "'.$yet_in_db[0] -> word_id.'"');
	}
	
}
function send_search($var){// If length search > $nb_caract = alert mail ## Si la longueur du mot recherch > $nb_caract alerte mail  l'admin
	global $wpdb;
	$table =  $wpdb -> prefix.'save_search_conf';
	$mail_admin = $wpdb -> get_results("SELECT * FROM $table WHERE id_nb_caract = 1");
	$destinataire = $mail_admin[0] -> mail_admin;
	$headers ='From: '.$destinataire."\n";
	$headers .='Reply-To:'.$destinataire."\n";
	$headers .='Content-Type: text/html; charset="iso-8859-1"'."\n";
	$headers .='Content-Transfer-Encoding: 8bit';

	$titre = 'Recherche effectue sur votre blog';
	$message  = "<html><body>\n";
	$message .= "<div style=\"font-family: arial;background: #101010; color: #cccccc; border: 1px solid #ffff86; padding: 20px; width: 500px;\">
					Recherche effectue:<br /><br /> ".$var."
				</div>";
	$message .="</body></html>";

	@mail($destinataire, $titre, $message, $headers);
}

is_one_search($_GET['s'],$_GET['d']); // Verify if we are on a result search page ## Vrifie si on est sur page de rsultats de recherche


function save_search_on_wordpress(){// Display wordcloud on frontpage ## Affiche le nuage de tags sur le front-office
	global $wpdb;
	$answer = ''; $i = 0;
	$table =  $wpdb -> prefix.'save_search_conf';
	$nbwords = $wpdb -> get_results("SELECT * FROM $table WHERE id_nb_caract = 1");
	$table =  $wpdb -> prefix.'save_search';
	$word_searched = $wpdb -> get_results('SELECT * FROM '.$table.' WHERE word_approuved = 1 ORDER BY word_time DESC LIMIT '.$nbwords[0] -> nb_word);
	if($word_searched != null){
		$answer = '<div class="box-right">				
						<h4 class="sidebar-title">Nuage de tags</h4>';
		foreach($word_searched AS $word){
			$link_search = str_replace(' ','+',$word -> word_name);
			$word = ($i%2 == 1) ? strtoupper($word -> word_name) : strtolower($word -> word_name);
			$fontsize = ($i%2 == 1) ? 12 : 13;
			$color = ($i%2 == 1) ? 'f99903' : 'ffffff';
			$answer .= '<a href="'.get_bloginfo('url').'/?s='.$link_search.'&submit=Go&d=1" style="text-decoration: none; font-size: '.$fontsize.'px; color: #'.$color.';">'.$word.'</a> &nbsp;';
			$i++;
		}
		$answer .= '</div>';	
	}
	echo $answer;
}


?>